#include <stdio.h>

#include <wchar.h>

#include <string.h>

#include <stdlib.h>

#include "hidapi.h"

#include <unistd.h>

int main(int argc, char * argv[]) {
  int res;
  unsigned char buf[256];
  hid_device * handle;
  int i;
  char * pMo[8];

  pMo[0] = (char * )
  "Balkonzimmer:";
  pMo[1] = (char * )
  "Vordach:";
  pMo[2] = (char * )
  "Schlafzimmer:";
  pMo[3] = (char * )
  "Wohnzimmer:";
  pMo[4] = (char * )
  "Bad:\t";
  pMo[5] = (char * )
  "WC:\t";
  pMo[6] = (char * )
  "Schuppen:";
  pMo[7] = (char * )
  "";

  system("systemctl stop klima.service");

  if (hid_init()) return -1;

  handle = hid_open(0x0483, 0x5750, NULL);

  if (!handle) {
    printf("unable to open device\n");
    return 1;
  }

  hid_set_nonblocking(handle, 1);

  memset(buf, 0, sizeof(buf));

  buf[0] = 0x7b;
  buf[1] = 0x03;
  buf[2] = 0x40;
  buf[3] = 0x7d;

  res = hid_write(handle, buf, 17);

  if (res < 0) {
    printf("Unable to write()\n");
    printf("Error: %ls\n", hid_error(handle));
  }

  res = 0;

  while (res == 0) {
    res = hid_read(handle, buf, sizeof(buf));
    if (res == 0)
      //			printf("waiting...\n");
      if (res < 0)
        printf("Unable to read()\n");
    usleep(1000 * 1000);
  }

  for (i = 0; i < 8; i++) {
    if (strlen(pMo[i])) printf("\r\n%s\t\t\t%d.%d°C\t\t%d\%\r\n", pMo[i], (256 * buf[1 + 3 * i] + buf[2 + 3 * i]) / 10, (256 * buf[1 + 3 * i] + buf[2 + 3 * i]) % 10, buf[3 + 3 * i]);
  }

  printf("\r\n");

  hid_close(handle);

  /* Free static HIDAPI objects. */
  hid_exit();

  sleep(2);
  system("systemctl start klima.service");

  return 0;
}